//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop



#include "LTR114_Test.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TLTR114TestForm *LTR114TestForm;
//---------------------------------------------------------------------------
__fastcall TLTR114TestForm::TLTR114TestForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
///  StartTest/StopTest     ( 
void TLTR114TestForm::ButtonEndis(bool start)
{
    if (start)
    {
        StartButton->Enabled = false;
        StopButton->Enabled = true;
    }
    else
    {
        StartButton->Enabled = true;
        StopButton->Enabled = false;
    }
}


//     i ( 0-) c     
//      4 . ,     
LTR114_LCHANNEL TLTR114TestForm::SetChannel(int index)
{
    //        
    int range_arr[LTR114_ADC_RANGEQNT] = {LTR114_URANGE_10, LTR114_URANGE_2, LTR114_URANGE_04};
    int measmode_arr[3] = {LTR114_MEASMODE_U, LTR114_MEASMODE_R, LTR114_MEASMODE_NR};
    switch (index)
    {
    case 0: return LTR114_CreateLChannel(measmode_arr[LCH1_ModeBox->ItemIndex], LCH1_ChannelBox->ItemIndex, range_arr[LCH1_GainBox->ItemIndex]);
    case 1: return LTR114_CreateLChannel(measmode_arr[LCH2_ModeBox->ItemIndex], LCH2_ChannelBox->ItemIndex, range_arr[LCH2_GainBox->ItemIndex]);
    case 2: return LTR114_CreateLChannel(measmode_arr[LCH3_ModeBox->ItemIndex], LCH3_ChannelBox->ItemIndex, range_arr[LCH3_GainBox->ItemIndex]);
    case 3: return LTR114_CreateLChannel(measmode_arr[LCH4_ModeBox->ItemIndex], LCH4_ChannelBox->ItemIndex, range_arr[LCH4_GainBox->ItemIndex]);
    default: return LTR114_CreateLChannel(0,0,0);
    }
}


// StartTest -      
//LTR114_ProcessThread   
void __fastcall TLTR114TestForm::StartButtonClick(TObject *Sender)
{
    int res,i;
    char *slot_str;
    AnsiString str;
    int slot;



    ButtonEndis(true);
    res = LTR114_Init(&hltr114);
    i = ModulesBox->ItemIndex;

    str = (*(ModulesBox->Items))[ModulesBox->ItemIndex];
    slot_str = &str.c_str()[5];  //   5-  ( 4 - 'Slot ')
    slot = StrToInt(slot_str);

    res = LTR114_Open(&hltr114, SADDR_DEFAULT, SPORT_DEFAULT,"", slot);
    if (res == LTR_OK)
        res = LTR114_GetConfig(&hltr114);
    if (res == LTR_OK)
    {
        // 
        hltr114.LChQnt = LChCntEdit->Value;
        for (i=0; i< hltr114.LChQnt; i++)
                hltr114.LChTbl[i] = SetChannel(i);
        hltr114.Interval = IntervalSpin->Value;
        hltr114.SpecialFeatures = (ThermCheckBox->Checked)? LTR114_FEATURES_THERM : 0;

        hltr114.AdcOsr = 0;
        hltr114.FreqDivider = FreqDividerSpin->Value;

        if (SyncModeBox->Text == "Internal")
            hltr114.SyncMode = LTR114_SYNCMODE_INTERNAL;
        else if (SyncModeBox->Text == "Master")
            hltr114.SyncMode = LTR114_SYNCMODE_MASTER ;
        else
            hltr114.SyncMode = LTR114_SYNCMODE_EXTERNAL;
        res = LTR114_SetADC(&hltr114);        //   
    }

    if (res == LTR_OK)
    {
        //  
        ltr_thread = new ltr114_ProcessThread(true);
        ltr_thread->pltr114 = &hltr114;
        ltr_thread->ltr_correction_mode = AutocbrModeBox->ItemIndex+1;
        //       
        ltr_thread->EditResArr[0] = LCh1Edit;
        ltr_thread->EditResArr[1] = LCh2Edit;
        ltr_thread->EditResArr[2] = LCh3Edit;
        ltr_thread->EditResArr[3] = LCh4Edit;
        ltr_thread->ThermEdit = ThermEdit;
        ltr_thread->OnTerminate = OnThreadTerminate;

        crit_sect->Enter();
        ltr_thread->Resume();  // 
        this->thread_run = true;
        crit_sect->Leave();
    }

    if (res!=LTR_OK)
    {
        Application->MessageBoxA(LTR114_GetErrorString(res), "LTR114_Error");
        ButtonEndis(false);
    }
}
//---------------------------------------------------------------------------

//,      
//  ,  thread_run
void __fastcall TLTR114TestForm::OnThreadTerminate(TObject *obj)
{
    StopButton->Enabled = false;
    crit_sect->Enter();
    this->thread_run = false;
    crit_sect->Leave();
    StartButton->Enabled = true;
}

//    -   
void __fastcall TLTR114TestForm::StopButtonClick(TObject *Sender)
{
    StopButton->Enabled = false;
    ltr_thread->SetLtrStatus(LTR114THREAD_STATUS_FORCE_STOP);
}
//---------------------------------------------------------------------------

//      
void __fastcall TLTR114TestForm::FreqDividerSpinChange(TObject *Sender)
{
       FreqEdit->Text = FloatToStr((double)LTR114_CLOCK*1000/(LTR114_ADC_DIVIDER * FreqDividerSpin->Value));
}
//---------------------------------------------------------------------------

//   FindLtr -    
void __fastcall TLTR114TestForm::FindLtrButtonClick(TObject *Sender)
{
    TLTR hltr;
    int res, i;
    char LTR_CratesSerial[CRATE_MAX][SERIAL_NUMBER_SIZE];  //   

    LTR_Init(&hltr);
    hltr.cc = CC_CONTROL;
    CratesBox->Items->Clear();

    res = LTR_Open(&hltr);
    if (res == LTR_OK)
        res = LTR_GetCrates(&hltr, &LTR_CratesSerial[0][0]); //  
    if (res == LTR_OK)
    {
        for (i=0 ; i< CRATE_MAX; i++)
            if (LTR_CratesSerial[i][0]!=' ')    //     
                CratesBox->Items->Add(LTR_CratesSerial[i]);
    }

    LTR_Close(&hltr);
    if (res!=LTR_OK)    //    . 
        Application->MessageBox(LTR114_GetErrorString(res), "LTR_Crates Error");

    if (CratesBox->Items->Count > 0)
    {             //   -     
       CratesBox->ItemIndex = 0;
       CratesBox->Enabled = true;
       CratesBoxChange(this);
    }
    else
    {   //  -  - disabled
        ModulesBox->Enabled = false;
        CratesBox->Enabled = false;
        StartButton->Enabled =false;
    }
}
//---------------------------------------------------------------------------
//     (    FindLtrButtonClick)
//   LTR114  
void __fastcall TLTR114TestForm::CratesBoxChange(TObject *Sender)
{
    TLTR hltr;
    char serial[SERIAL_NUMBER_SIZE];
    int i , res;
    WORD mid[MODULE_MAX];

    ModulesBox->Clear();
    strcpy(serial, (*(CratesBox->Items))[CratesBox->ItemIndex].c_str());

    LTR_Init(&hltr);
    hltr.cc =CC_CONTROL;
    strcpy(hltr.csn, serial); //   
    res=LTR_Open(&hltr);
    if (res==LTR_OK)
        res=LTR_GetCrateModules(&hltr, mid); //   
    if (res==LTR_OK)
    {
        for (i=0; i< MODULE_MAX; i++)
            if (mid[i]==LTR114_MID)     //   LTR114      
                ModulesBox->Items->Add("Slot "+IntToStr(i+1));
    }
    LTR_Close(&hltr);

    if (res!=LTR_OK)
        Application->MessageBox(LTR114_GetErrorString(res), "LTR_GetCrateModules Error");

    if (ModulesBox->Items->Count > 0)
    {
       ModulesBox->Enabled = true;
       ModulesBox->ItemIndex = 0;
       StartButton->Enabled = true;
    }
    else
    {
       ModulesBox->Enabled = false;
       StartButton->Enabled = false;
    }

}
//---------------------------------------------------------------------------

//         
void __fastcall TLTR114TestForm::FormCreate(TObject *Sender)
{
         thread_run = false;
        crit_sect = new TCriticalSection();
        FindLtrButtonClick(this);
}
//---------------------------------------------------------------------------


// -     (   . )
bool TLTR114TestForm::ThreadIsRun()
{
        bool res;
        crit_sect->Enter();
        res = thread_run;
        crit_sect->Leave();
        return res;
}

//  -    ( )   . 
void __fastcall TLTR114TestForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
        if (ThreadIsRun())      //   
             StopButtonClick(this);   //

        while (ThreadIsRun())      //  
        {
            Application->ProcessMessages();
            Sleep(200);
        }

        delete crit_sect;
}
//---------------------------------------------------------------------------

